<?php
 #########################################################################################
 #
 # Nom              : form2mail.php
 # Auteur           : Spin0us (spin0us@altern.org)
 # Date de creation : lundi 10 janvier 2005, 09h13
 #
 # Version          : 1.2.2 2005/01/24 15:09 Spin0us
 #
 #########################################################################################

 #########################################################################################
 #
 # Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes
 # de la Licence Publique Gnrale GNU publie par la Free Software Foundation (version 2
 # ou bien toute autre version ultrieure choisie par vous).
 #
 #########################################################################################

 ###
 ### CONFIGURATION
 ###
 ### Vous pouvez modifier cette partie du script pour l'adapter  votre site
 ###
 
 # Adresse mail du destinataire du mail
 # Vous pouvez prciser ici une adresse mail de destination dans le cas ou celle-ci
 # ne figure pas dans les champs de votre formulaire. En d'autres termes si vous n'avez
 # pas la balise HTML suivante : <input ... name="to" ... />
 # Si cette balise est dj prsente dans votre source, vous pouvez laisser ce paramtre
 # vide et/ou le mettre en commentaire.

 $form2mail['TO'] = '';
 
 # Adresse mail de l'expditeur
 # Vous pouvez prciser ici l'adresse mail de l'expditeur dans le cas ou celle-ci
 # ne figure pas dans les champs de votre formulaire. En d'autres termes si vous n'avez
 # pas la balise HTML suivante : <input ... name="from" ... />
 # Si cette balise est dj prsente dans votre source, vous pouvez laisser ce paramtre
 # vide et/ou le mettre en commentaire.

 $form2mail['FROM'] = '';
 
 # Sujet du mail
 # Vous pouvez prciser ici le sujet du mail dans le cas ou celui-ci ne figure pas dans
 # les champs de votre formulaire. En d'autres termes si vous n'avez pas la balise HTML
 # suivante : <input ... name="subject" ... />
 # Si cette balise est dj prsente dans votre source, vous pouvez laisser ce paramtre
 # vide et/ou le mettre en commentaire.
 
 $form2mail['SUBJECT'] = '';
 
 # Adresse de redirection aprs un envoi de mail russi
 # Vous pouvez prciser ici l'url ou sera redirig le script une fois son excution
 # termine, dans le cas ou celle-ci ne figure pas dans les champs de votre formulaire.
 # En d'autres termes si vous n'avez pas la balise HTML suivante : <input ... name="redirect" ... />
 # Si cette balise est dj prsente dans votre source, vous pouvez laisser ce paramtre
 # vide et/ou le mettre en commentaire.
 
 $form2mail['REDIRECT'] = '';
 
 # Adresse de redirection en cas d'erreur
 # Vous pouvez prciser ici l'url ou sera redirig le script en cas d'erreur de saisi,
 # dans le cas ou celle-ci ne figure pas dans les champs de votre formulaire. En d'autres
 # termes si vous n'avez pas la balise HTML suivante : <input ... name="error" ... />
 # Si cette balise est dj prsente dans votre source, vous pouvez laisser ce paramtre
 # vide et/ou le mettre en commentaire.
 
 $form2mail['ERROR'] = '';
 
 ### FIN DE LA PARTIE CONFIGURATION #####################################################






 ########################################################################################
 ####################### NE TOUCHEZ A RIEN DANS CE QUI SUIT #############################
 ########################################################################################






 ### DEBUT DU SCRIPT ####################################################################

 ### Fonction de test d'un email niveau syntaxe et existance du domaine avec le port 25
 function checkEmail($email) {
	### Test de la syntaxe
	if(eregi("^[a-zA-Z0-9_]+@[a-zA-Z0-9\-]+\.[a-zA-Z0-9\-\.]+$]", $email)) return FALSE;

	### Test du domaine
	list($Username, $Domain) = split("@",$email);

	//if(getmxrr($Domain, $MXHost)) return TRUE;
	if(long2ip(ip2long(gethostbyname($Domain))) != '255.255.255.255') return TRUE;
	else {
		if(fsockopen($Domain, 25, $errno, $errstr, 30)) return TRUE; 
		else return FALSE; 
	}
 }

 ### Liste des champs rservs/paramtrables
 $form2mail['FIELDS'] = array('TO','FROM','SUBJECT','REDIRECT','ERROR');

 ### Test des champs
 foreach($form2mail['FIELDS'] as $val)
 {
 	if( isset($_POST[$val]) && !empty($_POST[$val]) )
 		$form2mail[$val] = $_POST[$val];

  	elseif( ( isset($form2mail[$val]) && empty($form2mail[$val]) ) || !isset($form2mail[$val]) )
  		die("<b>Erreur dans le paramtrage du script</b>: il manque le champ $val");
 }
 
 		
 ### Tests de la conformit des champs
 if(!checkEmail($form2mail['TO']))   header("Location: ".$form2mail['ERROR']);
 if(!checkEmail($form2mail['FROM'])) header("Location: ".$form2mail['ERROR']);
 
 ### Construction du message avec les champs du formulaire non rservs/paramtrables
 $form2mail['MESSAGE'] = '';
 foreach($_POST as $key => $val)
 		if(!in_array($key,$form2mail['FIELDS']))
 			$form2mail['MESSAGE'] .= "$key: $val\r\n";
 
 ### Envoi du mail avec redirection en cas d'echec ou de russite
 if(mail($form2mail['TO'],$form2mail['SUBJECT'],$form2mail['MESSAGE'],"From: ".$form2mail['FROM']))
 	header("Location: ".$form2mail['REDIRECT']);
 else
 	header("Location: ".$form2mail['ERROR']);
 
 ### FIN DU SCRIPT ######################################################################
?>